package edu.umich.think.densityanalysis.service;

import java.util.ArrayList;

public class CorrelationService {
	public static double getPearsonCorrelation(ArrayList<Double> scores1,
			ArrayList<Double> scores2) {

		/**
		 * ffarfan 20100617
		 * Sometimes the Arraylists aren't the same size ...
		 * Compute maxscore as the smallest of the two sizes and then iterate
		 * through it. 
		 */
		int maxscore = 0;
		if(scores1.size() < scores2.size())
			maxscore = scores1.size();
		else
			maxscore = scores2.size();
		
		double result = 0;
		double sum_sq_x = 0;
		double sum_sq_y = 0;
		double sum_coproduct = 0;
		double mean_x = scores1.get(0);
		double mean_y = scores2.get(0);
//		for (int i = 2; i < scores1.size() + 1; i += 1) {
		for (int i = 2; i < maxscore + 1; i += 1) {
			double sweep = Double.valueOf(i - 1) / i;
			double delta_x = scores1.get(i - 1) - mean_x;
			double delta_y = scores2.get(i - 1) - mean_y;
			sum_sq_x += delta_x * delta_x * sweep;
			sum_sq_y += delta_y * delta_y * sweep;
			sum_coproduct += delta_x * delta_y * sweep;
			mean_x += delta_x / i;
			mean_y += delta_y / i;
		}
		double pop_sd_x = (double) Math.sqrt(sum_sq_x / scores1.size());
		double pop_sd_y = (double) Math.sqrt(sum_sq_y / scores1.size());
		double cov_x_y = sum_coproduct / scores1.size();
		result = cov_x_y / (pop_sd_x * pop_sd_y);
		return result;
	}
}
